local Me=CreateFrame("Frame","vZifnabsBufmon")
vZifnabs.mod.bufmon=Me
local mod=vZifnabs.mod
local L={}
local db=nil

local health={sound="RaidWarning",lastwarn=0}
local buff={}
local hands={}

-- -----------------------------------------------------------------
-- INITIALIZE
-- -----------------------------------------------------------------
function Me:Initialize()
	db=vZifnabsDB
	if not db.bufmon then db.bufmon={hud=true} end
	L=vZifnabs.L
	
	mod.core:RegisterEvent("TICK","bufmon",Me.Tick)
end

function Me:List()
	local mainBuff, mainExpire, mainCharges, offEnchant, offExpire, offCharges = GetWeaponEnchantInfo();
	mod.core:Print("mb="..(mainBuff or "nil"))
	mod.core:Print("me="..(mainExpire or "nil"))
	mod.core:Print("mc="..(mainCharges or "nil"))
	mod.core:Print("ob="..(offBuff or "nil"))
	mod.core:Print("oe="..(offExpire or "nil"))
	mod.core:Print("oc="..(offCharges or "nil"))
end

-- -----------------------------------------------------------------
-- CLOCK
-- -----------------------------------------------------------------
function Me:Tick(tick,ticktime)
	local dead=UnitIsDeadOrGhost("player")
	local healthpercent=math.floor(100*UnitHealth("player")/UnitHealthMax("player"))
	if healthpercent>=50 then health.lastwarn=0
	else
		local warnsound=nil
		if ticktime-health.lastwarn>5 then 
			warnsound=health.sound
			health.lastwarn=ticktime
		end
		if not dead then mod.hud:Write(mod.core:Repl(L.msg.lowhealth,"<percent>",healthpercent),warnsound,true) end		
	end
	
	for nr=0,19,1 do
		local texture=GetPlayerBuffTexture(nr)
		if texture==nil then break end
		local duration=GetPlayerBuffTimeLeft(nr)
		local endtime=ticktime+duration
		local parse=mod.core:Split(texture,"_")
		local buffname=parse[getn(parse)]
		if buff[buffname] and math.abs(buff[buffname].endtime-endtime)>5 then buff[buffname]=nil end
		if not buff[buffname] then buff[buffname]={texture=texture, duration=duration, start=ticktime} end
		buff[buffname].endtime=endtime -- adjust ending time
		buff[buffname].last=ticktime
		if buff[buffname].duration>40 and duration<20 and not buff[buffname].hud then
			buff[buffname].hud=true
			mod.hud:Write(mod.core:Repl(L.msg.fadingbuff,"<buff>",buffname),"RaidWarning")
		end
	end	
	
	for buffname,info in pairs(buff) do
		if buff[buffname].last~=ticktime then buff[buffname]=nil end
	end
	
	local mainbuff, mainlast, maincharges, offbuff, offlast, offcharges = GetWeaponEnchantInfo();
	if mainbuff and mainlast<20000 then mod.hud:Write(mod.core:Repl(L.msg.fadingbuff,"<buff>",L.keyword.mainhand),"RaidWarning") end
	if offbuff and offlast<20000 then mod.hud:Write(mod.core:Repl(L.msg.fadingbuff,"<buff>",L.keyword.offhand),"RaidWarning") end
end


-- -----------------------------------------------------------------
-- CLOCK
-- -----------------------------------------------------------------
function Me:BuffTarget()
	if UnitExists("target") and not UnitCanAttack("player","target") then
		local spell=nil
		local player=UnitClass("player")
		local target=UnitClass("target")
		if player=="WARLOCK" then spell=nil
		elseif player=="PALADIN" then
		end
		if spell then
		end
	end
end
